<template>
    <b-col class="pl-0 pr-0">
      <b-container fluid class="light-bg h-100 pl-0 pr-0">
        <b-nav tabs class="">
            <b-nav-item v-for="option in options" :key="option.value" :active="option.isSelected" @click="handleClick(option.value)">
              {{option.text}}
            </b-nav-item>
        </b-nav>
        <b-container fluid class="p-2">
          <!-- period picker -->
          <b-form inline class="justify-content-center mb-2">
            <b-form-group vertical :label-cols="4" label-size="sm" label="Start Date: " label-for="startDate">
                <b-form-input v-model="startDate" type="date" class="mb-2 ml-sm-2 mb-sm-0"></b-form-input>
                <b-form-input v-model="startTime" type="time" class="mb-2 ml-sm-2 mr-sm-4 mb-sm-0"></b-form-input>
            </b-form-group>
            <b-form-group vertical :label-cols="4" label-size="sm" label="End Date: " label-for="endDate">
                <b-form-input v-model="endDate" type="date" class="mb-2 ml-sm-2 mb-sm-0"></b-form-input>
                <b-form-input v-model="endTime" type="time" class="mb-2 ml-sm-2 mr-sm-4 mb-sm-0"></b-form-input>
            </b-form-group>
            <b-button @click="handleClick(options.find(e=>e.isSelected).value)" class="mb-2 ml-sm-2 mb-sm-0">
                Update
            </b-button>
          </b-form>
          <!-- chart -->
          <bar-chart :height="500" :chartData="chartData" :options="chartOptions"></bar-chart>
        </b-container>
      </b-container>
    </b-col>
</template>

<script>
import BarChart from './charts/BarChart.vue'

import Moment from 'moment'

export default {

  name: 'HistoricAllMeasures',

  components: {
    BarChart
  },

  data: function () {
    return {
      // List of tabs (all sensors except wind)
      options: this.$store.state.allCapteurs.filter(e => e.value !== 'wind').map((e, i) => {
        return { text: e.text, value: e.value, unit: e.unit, isSelected: i === 0 }
      }),
      // default value for period picker: last day
      endDate: Moment().format('YYYY-MM-DD'),
      endTime: Moment.utc().format('HH:mm'),
      startDate: Moment.utc().subtract(1, 'days').format('YYYY-MM-DD'),
      startTime: Moment.utc().format('HH:mm')
    }
  },

  computed: {
    chartData () {
      return {
        datasets: this.$store.state.historicMeasures.map((e, i) => {
          return {
            label: e.sonde_name,
            data: e.data,
            type: e.type, // line or bar chart
            borderColor: this.$store.state.colorPalette[i],
            backgroundColor: this.$store.state.colorPalette[i],
            fill: false,
            pointRadius: 0
          }
        })
      }
    },
    chartOptions () {
      return {
        responsive: true,
        maintainAspectRatio: false,
        tooltips: { mode: 'nearest', intersect: false },
        scales: {
          // linear time for X axis
          xAxes: [{ type: 'time', bounds: 'ticks' }],
          // adding the corresponding unit to the Y axis
          yAxes: [{ ticks: { callback: value => value + ' ' + this.options.find(e => e.isSelected).unit } }]
        }
      }
    }
  },

  mounted () {
    // generating timestamps from the selected dates and times (in seconds)
    var start = Moment(this.startDate + 'T' + this.startTime).unix()
    var end = Moment(this.endDate + 'T' + this.endTime).unix()
    // get all sondes historic values for the selected sensor during the selected period
    this.$store.dispatch('getHistoricMeasures', [ this.options.find(e => e.isSelected).value, start, end ])
  },

  methods: {

    handleClick (e) {
      var start = Moment(this.startDate + 'T' + this.startTime).unix()
      var end = Moment(this.endDate + 'T' + this.endTime).unix()
      this.$store.dispatch('getHistoricMeasures', [ e, start, end ])
      // change isSelected attribute to match the selected tab
      this.options.forEach(elem => {
        if (elem.value !== e) elem.isSelected = false
        else elem.isSelected = true
      })
    }

  }
}
</script>

<style>
.form-control{
  height: 2.25rem !important;
  font-size: 0.9rem !important;
  background-color: #dfdce3 !important;
  border: 0.5px solid #fff !important;
  border-radius: 0% !important;
}
.btn{
  color: #262228 !important;
  background-color: #dfdce3 !important;
  border: 0.5px solid #fff !important;
  border-radius: 0% !important;
}
</style>
